#ifndef _SERIAL_H
#define _SERIAL_H

#ifdef _WIN32
#include <SDL/SDL.h>
#else
#include <SDL2/SDL.h>
#endif

class CSerial {

protected:
	static unsigned int NrOfDevicesAttached;
    static CSerial *RootDevice;
    static CSerial *LastDevice;
	CSerial *PrevDevice;
    CSerial *NextDevice;
	char Name[16];
public:
	CSerial();
	~CSerial();
	CSerial(unsigned int DevNr);
	// State of IEC lines (bit 7 - DATA, bit 6 - CLK, bit 4 - ATN)
	static unsigned char Line[16];
	static void InitPorts();
	unsigned char ReadBus();
	Uint32 DeviceNr;
	virtual void UpdateSerialState(unsigned char ) { };
	//virtual void ReadSerialState(unsigned char ) { };
	static class CSerial *Devices[16];

	friend class TEDMEM;
};

// class for not real devices (printer)
class CRealSerialIEC : public CSerial {
	virtual void NewSerialState(unsigned char Clk);
};

class IEC;

// class for not real devices (printer)
class CFakeSerialIEC : public CSerial {
	virtual void NewSerialState(unsigned char Clk);
	IEC *iec;
};

// class for true serial drive emulation
class CTrueSerialIEC : public CSerial {
	virtual void NewSerialState(Uint32 Clk);
};

#endif // _SERIAL_H

